import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.InputStream;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class Pexeso extends JFrame {
	/**
	 *
	 */
	private static final long serialVersionUID = 2118528597102312174L;

	private static Pexeso app;

	private JPanel jContentPane = null;
	private JMenuBar jJMenuBar = null;
	private JMenu jMenu_Game = null;
	private JMenu jMenu_About = null;
	private JMenuItem jMenuItem_Game_New = null;
	private JMenuItem jMenuItem_Game_End = null;

	//Moje uprava
	private boolean package_loaded = false; // nacten balik pexesa?
	private String package_path; // cesta k baliku pexesa
	//private String package_name;
	//private String package_author;
	private int package_card_width; // sirka karticky pexesa
	private int package_card_height; // vyska karticky pexesa
	private BufferedImage[] package_card_image; // obrazky licu
	private BufferedImage package_card_back; // obrazek rubu
	private int[] card_position; // cislo lice na prislusne pozici
	private int[] card_state; // stav karty: 0 = neotocena, -1 = otocena, -2 = sebrana
	private int[] card_position_x; // x-souradnice karty na plose od horniho leveho rohu
	private int[] card_position_y; // y-souradnice karty na plose od horniho leveho rohu
	private int numSelected = 0; // pocet otocenych karet
	private int lastSelected = -1; // pozice prvni otocene karty
	private int lastSelectedSecond = -1; // poyice druhe otocene karty
	private Timer t;
	private boolean waitOnTimer; // nepovolit dalsi kliknuti pokud se ceka na casovac ktery, otoci karty nebo je sebere
	private int ubehlo = 0; // cas ubehly od zacatku hry
	private int sebrano = 0; // pocet sebranych dvojic

	private JDialog jDialogNew = null;  //  @jve:decl-index=0:visual-constraint="638,78"
	private JPanel jContentPaneNew = null;
	private JLabel jLabel1 = null;
	private JComboBox jComboBoxPackage = null;
	private JButton jButton = null;
	private JMenuItem jMenuItem_About_Programm = null;

	private Timer cas = null;  //  @jve:decl-index=0:visual-constraint="631,210"
	private Platno platno = null;
	private JLabel jLabel_Status = null;

	/**
	 * This method initializes jJMenuBar
	 *
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu_Game());
			jJMenuBar.add(getJMenu_About());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu_Game
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu_Game() {
		if (jMenu_Game == null) {
			jMenu_Game = new JMenu();
			jMenu_Game.setText("Hra");
			jMenu_Game.add(getJMenuItem_Game_New());
			jMenu_Game.addSeparator();
			jMenu_Game.add(getJMenuItem_Game_End());
		}
		return jMenu_Game;
	}

	/**
	 * This method initializes jMenu_About
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu_About() {
		if (jMenu_About == null) {
			jMenu_About = new JMenu();
			jMenu_About.setText("O...");
			jMenu_About.add(getJMenuItem_About_Programm());
		}
		return jMenu_About;
	}

	/**
	 * This method initializes jMenuItem_Game_New
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem_Game_New() {
		if (jMenuItem_Game_New == null) {
			jMenuItem_Game_New = new JMenuItem();
			jMenuItem_Game_New.setText("Nov");
			jMenuItem_Game_New.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					// zobrazime dialog na vyber baliku
					zobrazVyberDialog();
					if (package_path == null) return;
					if (package_path.length() == 0) return;

					// pokd byl vybran balik, nactem balik
					nactiBalik("baliky/" + package_path);

					// vytvorime potrebna pole
					card_position = new int[package_card_image.length * 2];
					card_position_x = new int[package_card_image.length * 2];
					card_position_y = new int[package_card_image.length * 2];
					card_state = new int[package_card_image.length * 2];

					// provedeme nastaveni cisla rubu - dvakrat po sobe ocislujeme od 1 do poctu nactenych rubu
					// a i nastaveni stavu karticky
					for(int i = 0; i < card_position.length; i++) {
						card_position[i] = i % card_position.length / 2;
						card_state[i] = 0;
					}

					// provedeme rozhazeni karticek metodou nahodne vymeny, toto provdeme 4x
					for(int i = 0; i < card_position.length * 4; i++) {
						int k = (int)Math.floor(Math.random() * (double)card_position.length);
						int l = (int)Math.floor(Math.random() * (double)card_position.length);
						int iTmp = card_position[k];
						card_position[k] = card_position[l];
						card_position[l] = iTmp;
					}
					jLabel_Status.setVisible(true);

					app.repaint();
					// pokud nevypnu casovac, tak proste casovac jede dal i kdyz provedu cas = null;
					if (cas!=null) cas.cancel();
					cas = null;
					app.ubehlo = 0;
					app.sebrano = 0;
					app.prekresliCasomiru();
					cas = getCas();
					// vytvorime casovac, ktery zobrazuje ubehly cas
					cas.scheduleAtFixedRate(new TimerTask() {
						public void run() {
							app.ubehlo++;
							app.prekresliCasomiru();
						}
					}, 1000, 1000);

				}
			});
		}
		return jMenuItem_Game_New;
	}

	/**
	 * Funkce se stara o zmenu labelu, kde je zobrazen ubehly cas a pocet sebranych dvojic karticek
	 */
	private void prekresliCasomiru() {
		jLabel_Status.setText(this.ubehlo + " s.  Sebrno "+this.sebrano+" z "+this.package_card_image.length+".");
	}

	/**
	 * This method initializes jMenuItem_Game_End
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem_Game_End() {
		if (jMenuItem_Game_End == null) {
			jMenuItem_Game_End = new JMenuItem();
			jMenuItem_Game_End.setText("Konec");
			jMenuItem_Game_End.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					System.exit(0);
				}
			});
		}
		return jMenuItem_Game_End;
	}

	/**
	 * This method initializes jDialogNew
	 *
	 * @return javax.swing.JDialog
	 */
	private JDialog getJDialogNew() {
		if (jDialogNew == null) {
			jDialogNew = new JDialog();
			jDialogNew.setSize(new java.awt.Dimension(226,89));
			jDialogNew.setTitle("Nov hra");
			jDialogNew.setModal(true);
			jDialogNew.setContentPane(getJContentPaneNew());
			jDialogNew.setResizable(false);
		}
		return jDialogNew;
	}

	/**
	 * This method initializes jContentPaneNew
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPaneNew() {
		if (jContentPaneNew == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 9;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.gridwidth = 5;
			gridBagConstraints2.gridheight = 2;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.CENTER;
			gridBagConstraints2.insets = new java.awt.Insets(5,0,0,0);
			gridBagConstraints2.gridy = 9;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.gridheight = 1;
			gridBagConstraints1.gridwidth = 0;
			gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints1.insets = new java.awt.Insets(5,0,0,0);
			gridBagConstraints1.gridx = 5;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(5,0,0,0);
			gridBagConstraints.gridy = 1;
			gridBagConstraints.ipadx = 5;
			gridBagConstraints.ipady = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.CENTER;
			gridBagConstraints.gridwidth = 1;
			gridBagConstraints.gridheight = 1;
			gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints.gridx = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("Sada pexesa:");
			jLabel1.setName("jLabel1");
			jContentPaneNew = new JPanel();
			jContentPaneNew.setLayout(new GridBagLayout());
			jContentPaneNew.add(jLabel1, gridBagConstraints);
			jContentPaneNew.add(getJComboBoxPackage(), gridBagConstraints1);
			jContentPaneNew.add(getJButton(), gridBagConstraints2);
		}
		return jContentPaneNew;
	}

	/**
	 * This method initializes jComboBox
	 *
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxPackage() {
		if (jComboBoxPackage == null) {
			jComboBoxPackage = new JComboBox();
			jComboBoxPackage.setName("jComboBoxPackage");
		}
		return jComboBoxPackage;
	}

	/**
	 * This method initializes jButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Zat");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					package_path = (String)((myComboItem)jComboBoxPackage.getSelectedItem()).itemData;
					jDialogNew.setVisible(false);
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jMenuItem_About_Programm
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem_About_Programm() {
		if (jMenuItem_About_Programm == null) {
			jMenuItem_About_Programm = new JMenuItem();
			jMenuItem_About_Programm.setText("O programu...");
			jMenuItem_About_Programm.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()");
					JOptionPane.showMessageDialog(null, "Sesmolil Arcao v ramci semestrlky z pedmtu PGS.\nPipomnky pite na arcao@arcao.com.",app.getTitle(), JOptionPane.INFORMATION_MESSAGE);
				}
			});
		}
		return jMenuItem_About_Programm;
	}

	/**
	 * This method initializes cas
	 *
	 * @return java.util.Timer
	 */
	private Timer getCas() {
		if (cas == null) {
			cas = new Timer();
		}
		return cas;
	}

	/**
	 * This method initializes platno
	 *
	 * @return javax.swing.JPanel
	 */
	private Platno getPlatno() {
		if (platno == null) {
			jLabel_Status = new JLabel();
			jLabel_Status.setText("JLabel");
			jLabel_Status.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
			jLabel_Status.setVisible(false);
			platno = new Platno();
			platno.app = this;
			platno.setDoubleBuffered(true);
			platno.add(jLabel_Status, null);
			platno.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mousePressed(java.awt.event.MouseEvent e) {
					System.out.println("mousePressed()");
					zpracujClick(e.getX(), e.getY());


					if (waitOnTimer || !package_loaded) return;

					// little cheat :)
					if (e.isShiftDown() && e.isAltDown() && e.isControlDown()) {
						for(int i = 0; i < card_state.length; i++) card_state[i] = -2;
						sebrano = package_card_image.length;
						kontrolujVyhru();
						app.repaint();
					}
				}
			});
		}
		return platno;
	}

	/**
	 * Spousteci metoda
	 *
	 * @param args
	 */
	public static void main(String[] args) {
		app = new Pexeso();
		app.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public Pexeso() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(624, 602);
		this.setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/pexeso-ico.png")));
		this.setTitle("Pexeso by Arcao, aneb PEKeln SE SOuste");
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setVisible(true);
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getPlatno(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * Funkce nacita balik, tj. nastavi package_card_width, package_card_height a
	 * nacte obrazky rubu a obrazek lice
	 */
	private void nactiBalik(String cesta) {
        // Build the document with SAX and Xerces, no validation
        SAXBuilder builder = new SAXBuilder();
        // Create the document
    	Document dom;
    	System.out.println("Nacitam balik: "+ cesta);
        try {
			dom = builder.build(getClass().getResourceAsStream(cesta + "/balik.xml"));

			//package_name = dom.getRootElement().getChild("jmeno").getText();
			//package_author = dom.getRootElement().getChild("autor").getText();
			package_card_width = Integer.valueOf(dom.getRootElement().getChild("velikost").getChild("sirka").getText()).intValue();
			package_card_height = Integer.valueOf(dom.getRootElement().getChild("velikost").getChild("vyska").getText()).intValue();

			List files = dom.getRootElement().getChild("obrazky").getChildren("obrazek");

			package_card_image = new BufferedImage[files.size()];
			for(int i=0;i<files.size();i++) {
				System.out.println("load: "+ cesta + "/" + ((Element)files.get(i)).getText());
				package_card_image[i] = ImageIO.read(getClass().getResourceAsStream(cesta + "/" + ((Element)files.get(i)).getText()));
			}

			package_card_back = ImageIO.read(getClass().getResourceAsStream(cesta + "/" + dom.getRootElement().getChild("rub").getText()));
			dom = null;
			package_loaded = true;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	/**
	 * Funkce se stara o prekresleni karticek vcetne vypoctu novych pozic umisteni
	 */
	public void vykresli(Graphics gr) {
		int maxCardsPerLine;
		int counter;

		Graphics2D g = (Graphics2D) gr;
		//Graphics g = getPlatno().getGraphics();
		// vymazeme platno
		g.clearRect(0, 0, getPlatno().getWidth(), getPlatno().getHeight());

		if (!package_loaded) return;

		// zjistime kolik se na platno vejde sloupcu
		maxCardsPerLine = getPlatno().getWidth() / (10 + package_card_width);

		// na platne bude 3-6 sloupcu
		if (maxCardsPerLine < 3) maxCardsPerLine = 3;
		if (maxCardsPerLine > 6) maxCardsPerLine = 6;

		// prvni radek
		int x = (getPlatno().getWidth() - (10 + package_card_width) * maxCardsPerLine) / 2;
		int y = 10 + jLabel_Status.getHeight();

		counter = 0;
		for(int i = 0; i < card_position.length; i++) {
			if (counter == maxCardsPerLine) {
				// novy radek
				y+= package_card_height + 10;
				x = (getPlatno().getWidth() - (10 + package_card_width) * maxCardsPerLine) / 2;
				counter = 0;
			}
			// neotocena karticka
			if (card_state[i] == 0) {
				g.drawImage(package_card_back, x, y, null);
			// otocena karticka
			} else if (card_state[i] == -1) {
				g.drawImage(package_card_image[card_position[i]], x, y, null);
			// sebrana karticka
			} else if (card_state[i] == -2) {
				g.clearRect(x, y, package_card_width, package_card_height);
			}

			// nastaveni novych pozic
			card_position_x[i] = x;
			card_position_y[i] = y;

			// pocitadlo karet na radku
			counter++;

			// nova karta na radku
			x+= package_card_width + 10;
		}
	}

	/**
	 * Puvodne slouzilo k vykresleni jen jedne karty, nez bylo vykreslovani
	 * udelano pres paintComponent() v tride Platno.
	 */
	private void vykresli(int item) {
		if (!package_loaded) return;
		platno.repaint();
	}

	/**
	 * Funkce zjistuje, zda a pozici x a y se nachazi karta pripadne podle stavu
	 * otaci, ci sbira karticky
	 */
	private void zpracujClick(int x, int y) {
		if (waitOnTimer || !package_loaded) return;

		for(int i = 0; i < card_position.length; i++) {
			// kliknuto na kartu? a na kterou?
			if (card_position_x[i] <= x &&
				card_position_x[i] + package_card_width >= x &&
				card_position_y[i] <= y &&
				card_position_y[i] + package_card_height >= y) {
				if (card_state[i] == 0) {
					if (numSelected == 1) {
						if (card_position[lastSelected] == card_position[i]) {
							// hrac se trefil - otocil dve stejne karty

							// karticky otocime
							card_state[lastSelected] = -1;
							vykresli(lastSelected);
							card_state[i] = -1;
							vykresli(i);

							lastSelectedSecond = i;
							// zakazeme dalsi kliknuti
							waitOnTimer = true;

							// a timer je po sekunde sebere
							t = new Timer();
							t.schedule(new TimerTask() {
								public void run() {
									this.cancel();

									card_state[lastSelected] = -2;
									vykresli(lastSelected);
									lastSelected = -1;

									card_state[lastSelectedSecond] = -2;
									vykresli(lastSelectedSecond);
									lastSelectedSecond = -1;

									numSelected = 0;

									// zvednem cislovadlo, ktere udrzuje pocet sebranych dvojic
									sebrano++;

									// zkontrolujeme, zda jsou jeste na hraci plose karticky
									kontrolujVyhru();
									// povolime dalsi kliknuti
									waitOnTimer = false;
								}
							}, 1000);
						} else {
							// netrefil - dve ruzne karticky
							waitOnTimer = true;

							// otocime druhou kartu
							card_state[i] = -1;
							vykresli(i);
							lastSelectedSecond = i;

							// po jedne sekunde je otocime zase zpet
							t = new Timer();
							t.schedule(new TimerTask() {
								public void run() {
									this.cancel();

									// otocime prvni kartu
									card_state[lastSelected] = 0;
									vykresli(lastSelected);
									lastSelected = -1;

									// a i druhou
									card_state[lastSelectedSecond] = 0;
									vykresli(lastSelectedSecond);
									lastSelectedSecond = -1;

									// vynulujem pocitadlo poctu otocenych karticek
									numSelected = 0;

									// povolime zas klikani
									waitOnTimer = false;
								}
							}, 1000);
						}
					} else {
						// otocil prvni karticku
						numSelected++;
						card_state[i] = -1;

						vykresli(i);

						lastSelected = i;
					}
				} else if (card_state[i] == -1) {
					// hrac prvni otocenou karticku chce zas otocit zpet
					card_state[i] = 0;
					numSelected--;
					vykresli(i);
					lastSelected = -1;
				}
			}
		}
	}

	/**
	 * Tato funkce je volana pri kazdem uspesnem sebrani dvojce a kontroluje,
	 * zda se jeste na hraci plose nachazi karticky
	 */
	private void kontrolujVyhru() {
		jLabel_Status.setText(ubehlo + " s.  Sebrno "+sebrano+" z "+package_card_image.length+".");

		// nalezena nesebrana karticka, tak vyzkoc z teto funkce
		for(int i = 0; i < card_position.length; i++) if (card_state[i] != -2) return;

		// neni nacten balik
		package_loaded = false;
		cas.cancel();
		// zobrazime informujici dialog o vyhre
		JOptionPane.showMessageDialog(null, "Sebral si ve za "+ubehlo+" sekund. Skus bt jet lep!!!", this.getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	/**
	 * Funkce nacita z baliky.xml seznam pouzitelnych baliku a zobrazuje je
	 * v dialogu, kde si muze hrac vybrat, ktery balik karticek chce mit na hraci
	 * plose
	 */
	private void zobrazVyberDialog() {
		try {
			// Build the document with SAX and Xerces, no validation
			SAXBuilder builder = new SAXBuilder();
			// Create the document
			Document domlist;

			// vytvorime vyber dialog
			jDialogNew = this.getJDialogNew();
			// smazeme vsechny polozky z comboboxu
			jComboBoxPackage.removeAllItems();

			// nacteme baliky.xml
			domlist = builder.build(getClass().getResourceAsStream("baliky/baliky.xml"));
			// chceme vsechny elementy jmeno
			List item = domlist.getRootElement().getChildren("jmeno");

			// projedem vsechny elementy jmeno
			for(int i = 0; i < item.size(); i++) {
					// vytvorime inputstream ze souboru baliky/[jmeno]/balik.xml
					InputStream fBalik = getClass().getResourceAsStream("baliky/"+((Element)item.get(i)).getText()+"/balik.xml");
					if (fBalik == null) continue;

					// Create the document
					Document dom;

					// nactem tento xml soubor z is
					dom = builder.build(fBalik);

					// pridame balik do comboboxu
					jComboBoxPackage.addItem(new myComboItem(dom.getRootElement().getChild("jmeno").getText(), ((Element)item.get(i)).getText()));
					dom = null;
			}
			domlist = null;
			package_path = null;
			// zobrazime vyber dialog
			jDialogNew.setLocation(this.getX() + (this.getWidth() -  jDialogNew.getWidth())/2, this.getY() + (this.getHeight() -  jDialogNew.getHeight())/2);
			jDialogNew.setVisible(true);
			jDialogNew.setSize(new java.awt.Dimension(183,118));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Trida starajici se o ulozeni dat v comboboxu, v dialogu pro vyber baliku
	 * karticek
	 */
	private class myComboItem {
		public String item;
		public Object itemData;

		// konstruktor vytvari jmeno polozky a ulozny prostor pro jakykoliv object
		public myComboItem(String item, Object itemData) {
			this.item = item;
			this.itemData = itemData;
		}
		// tato funkce vraci to co se zobrazi v comboboxu
		public String toString() {
			return this.item;
		}
	}
}  //  @jve:decl-index=0:visual-constraint="0,2"
